diff a/src/hotspot/share/opto/runtime.hpp b/src/hotspot/share/opto/runtime.hpp
--- a/src/hotspot/share/opto/runtime.hpp
+++ b/src/hotspot/share/opto/runtime.hpp
@@ -98,11 +98,11 @@
 
 typedef const TypeFunc*(*TypeFunc_generator)();
 
 class OptoRuntime : public AllStatic {
   friend class Matcher;  // allow access to stub names
-
+  friend class SCAddressTable;
  private:
   // define stubs
   static address generate_stub(ciEnv* ci_env, TypeFunc_generator gen, address C_function, const char* name, int is_fancy_jump, bool pass_tls, bool return_pc);
 
   // References to generated stubs
@@ -120,10 +120,11 @@
   static address _monitor_notify_Java;
   static address _monitor_notifyAll_Java;
 
   static address _slow_arraycopy_Java;
   static address _register_finalizer_Java;
+  static address _class_init_barrier_Java;
 #if INCLUDE_JVMTI
   static address _notify_jvmti_vthread_start;
   static address _notify_jvmti_vthread_end;
   static address _notify_jvmti_vthread_mount;
   static address _notify_jvmti_vthread_unmount;
@@ -171,10 +172,11 @@
   static ExceptionBlob*       _exception_blob;
   static void generate_exception_blob();
 
   static void register_finalizer(oopDesc* obj, JavaThread* current);
 
+  static void class_init_barrier(Klass* k, JavaThread* current);
  public:
 
   static bool is_callee_saved_register(MachRegisterNumbers reg);
 
   // One time only generate runtime code stubs. Returns true
@@ -199,10 +201,11 @@
   static address monitor_notify_Java()                   { return _monitor_notify_Java; }
   static address monitor_notifyAll_Java()                { return _monitor_notifyAll_Java; }
 
   static address slow_arraycopy_Java()                   { return _slow_arraycopy_Java; }
   static address register_finalizer_Java()               { return _register_finalizer_Java; }
+  static address class_init_barrier_Java()               { return _class_init_barrier_Java; }
 #if INCLUDE_JVMTI
   static address notify_jvmti_vthread_start()            { return _notify_jvmti_vthread_start; }
   static address notify_jvmti_vthread_end()              { return _notify_jvmti_vthread_end; }
   static address notify_jvmti_vthread_mount()            { return _notify_jvmti_vthread_mount; }
   static address notify_jvmti_vthread_unmount()          { return _notify_jvmti_vthread_unmount; }
@@ -297,10 +300,12 @@
   // leaf on stack replacement interpreter accessor types
   static const TypeFunc* osr_end_Type();
 
   static const TypeFunc* register_finalizer_Type();
 
+  static const TypeFunc* class_init_barrier_Type();
+
   JFR_ONLY(static const TypeFunc* class_id_load_barrier_Type();)
 #if INCLUDE_JVMTI
   static const TypeFunc* notify_jvmti_vthread_Type();
 #endif
 
@@ -317,8 +322,11 @@
  static NamedCounter* new_named_counter(JVMState* jvms, NamedCounter::CounterTag tag);
 
  // dumps all the named counters
  static void          print_named_counters();
 
+ public:
+  static void init_counters();
+  static void print_counters_on(outputStream* st);
 };
 
 #endif // SHARE_OPTO_RUNTIME_HPP
